using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Pdf;
using System.Globalization ;
namespace EssentialPDFSamples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private DataSet dsNorthWind;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(88, 24);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "PDF";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(264, 78);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.Text = "Essential PDF Sample";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//Create a new PDF Document. This object represents the whole PDF document.
			//This document had One page by default. Additional pages have to be added.
			PDFDocument pdfDoc = new PDFDocument();	
			
			//Adding Header
			this.AddHeader(pdfDoc,"Syncfusion Essential PDF","Northwind Customers");

			//Adding Footer.
			this.AddFooter(pdfDoc,true);

			//Accessing the first page in the pages collection.
			IPDFPage firstPage = pdfDoc.Pages[0];
			
			//Create a new PDF Table
			ITable table = pdfDoc.CreateTable();

            //Get the Northwind DataTable
			dsNorthWind =GetDataSet();

            //Importing a DataTable
			table.DataMember = dsNorthWind.Tables[0].TableName;
			table.DataSource = dsNorthWind;
			table.ConfigureTable( dsNorthWind.Tables[0] );

            //Setting Table Properties
			table.Style.BorderColors.All = Color.FromArgb( 0x82, 0x2e, 0x1b );
			table.Style.BordersWidth.All = 1;
			
			//Fonts to be used inside the table header rows and body rows.
			IPDFFont customersTableTitleFont = pdfDoc.Fonts.Add( new Font( "courier", 6, FontStyle.Bold )  );
			IPDFFont customersTableBodyFont = pdfDoc.Fonts.Add( new Font( "courier", 6, FontStyle.Regular )  );
	
			//Format the Header Rows
			for( int i = 0, len = table.Columns.Count; i < len; ++i )
			{
				table.Header[0].Cells[i].Style.BackColor = Color.FromArgb( 252, 172, 38 );
				table.Header[0].Cells[i].Style.TextFont = customersTableTitleFont;
				table.Header[0].Cells[i].Style.BorderColors.All = Color.FromArgb( 0x82, 0x2e, 0x1b );
				table.Header[0].Cells[i].Style.BordersWidth.All = 0;
			}

			//Format the tables
			for( int i = 0; i < table.Rows.Count; ++i )
			{
				for(int j=0; j< table.Columns.Count;++j)
				{
					table.Rows[i].Cells[j].Style.BackColor = Color.FromArgb( 219, 226, 242 );
					table.Rows[i].Cells[j].Style.TextFont = customersTableBodyFont;
					table.Rows[i].Cells[j].Style.BorderColors.All = Color.FromArgb( 0x82, 0x2e, 0x1b );
					table.Rows[i].Cells[j].Style.BordersWidth.All = 0;
				}
			}

			//To make the Table span over multiple pages without getting cut.
			table.PageBreakBehavior = AutoBreakBehavior.FullBreak;

			float totalDataColWidth = 0;
			for( int i = 0, len = table.Columns.Count; i < len; ++i )
			{
				totalDataColWidth = totalDataColWidth + pdfDoc.Graphics.MeasureString(table.Columns[ i ].DataColumnName,customersTableTitleFont).Width;
			}

			for( int i = 0, len = table.Columns.Count; i < len; ++i )
			{
				table.Columns[ i ].Width = pdfDoc.Graphics.MeasureString(table.Columns[ i ].DataColumnName,customersTableTitleFont).Width + ((pdfDoc.Pages[0].DrawingWidth -totalDataColWidth)/table.Columns.Count );
			}		

			table.RepeateHeader = true;
			
			//Draw the table to the specified page
			table.Publish( new PointF( 0, 0 ),pdfDoc.Pages[0]);

			//Save the PDF Document to disk.
			pdfDoc.Save("Sample.pdf");
			
			//Message box confirmation to view the created PDF document.
			if (MessageBox.Show ("Do you want to view the PDF file?", "PDF File Created",
				MessageBoxButtons.YesNo, MessageBoxIcon.Information)
				== DialogResult.Yes) 
			{
				//Launching the PDF file using the default Application.[Acrobat Reader]
				System.Diagnostics.Process.Start("Sample.pdf");
			}
			else
			{
				// Exit
				this.Close();
			}
		}

		private DataSet GetDataSet()
		{
			//Create the Blank DataSet
			DataSet dataSet11 = new DataSet();
			//Read the data from XML.
			dataSet11.ReadXml(@"..\..\..\Data\customers.xml");

			return dataSet11;		

		}

		private void AddHeader( IPDFDocument doc, string title, string description )
		{
			if( doc == null )
			{
				throw new ArgumentNullException( "doc" );
			}

			if( title == null )
			{
				throw new ArgumentNullException( "title" );
			}

			const int offset = 10;

			// Add the header   
			ITemplate header = doc.CreateTemplate();
			//Add the font that will be used in the header
			IPDFFont font = doc.Fonts.Add( FontBaseFamily.HelveticaBold );
			//Define font properties for the header.
			font.Size = 24;
			//Just to make sure that we have enough space in the header.
			float doubleHeight = font.Height * 2;
			Color activeColor = Color.FromArgb( 44, 71, 120 );

			//Add Logo Image
			//IPDFGraphicState is used for setting properties of all drawing objects.
			IPDFGraphicState props = doc.CreateGraphicState();
			SizeF imageSize = new SizeF( 110f, 35f );
			//Locating the logo on the right corner of the Drawing Surface
			PointF imageLocation = new PointF( doc.LastPage.DrawingWidth - imageSize.Width, 15 );      
			props.Padding = new PDFPadding( offset, offset, 0, 0 );
			doc.Images.Add(@"..\..\..\Data\logo.jpg");
			IPDFImage logoImage = doc.Images[0];
			//Draw the image in the Header.
			header.Graphics.DrawImage(imageLocation,logoImage,imageSize, props );

			//Add Title Tab
			props = doc.CreateGraphicState();
			props.TextAlignment = TextAlignment.Center;
			props.ForeColor = activeColor;
			props.Scale( 0.8f, 0.7f );
			props.Padding = new PDFPadding( offset * 2, 0, ( int )imageSize.Width, 0 );
			header.Graphics.DrawMultiText( offset, 5, doc.LastPage.DrawingWidth, font.Height, title, font, props );

			SizeF headerSize;
			//Add description tag
			if( description != null && description.Length > 0 )
			{
				headerSize = header.Size;
				font = doc.Fonts.Add( FontBaseFamily.HelveticaOblique );
				font.Size = 8;
				props = doc.CreateGraphicState();
				props.TextAlignment = TextAlignment.Left;
				props.Padding = new PDFPadding( offset, 0, 0, 0 );
				props.ForeColor = Color.Gray;
				header.Graphics.DrawMultiText( 0, headerSize.Height,
					doc.LastPage.DrawingWidth, font.Height, description, font, props );
			}
			//Add the border effect.
			headerSize = header.Size;
			headerSize.Height += 10;
			activeColor = Color.FromArgb( 139, 164, 204 );

			props = doc.CreateGraphicState();
			props.ForeColor = activeColor;
			header.Graphics.DrawLine( 0, 0, headerSize.Width-10, 0 );
			header.Graphics.DrawLine( 0, headerSize.Height, headerSize.Width-10, headerSize.Height );

			header.Graphics.DrawLine( 0, 0, 0, headerSize.Height );

			header.Graphics.DrawLine( headerSize.Width-10, 0, headerSize.Width-10, headerSize.Height );


			props = doc.CreateGraphicState();
			props.LineWidth = 2;
			props.ForeColor = activeColor;
			header.Graphics.DrawLine( 0, 2, headerSize.Width-10, 2, props );
			header.Graphics.DrawLine( 0, headerSize.Height - 2, headerSize.Width-10, headerSize.Height - 2, props );

			header.Graphics.DrawLine( 0, 5, headerSize.Width-10, 5 );
			header.Graphics.DrawLine( 0, headerSize.Height - 5, headerSize.Width-10, headerSize.Height - 5 );

			doc.Header = header;      
		}

		private void AddFooter( IPDFDocument doc , bool isLeftRightBarPresents )
		{   
			//Creating a Footer object.
			ITemplate footer = doc.CreateTemplate();

			IPDFFont font = doc.Fonts.Add( FontBaseFamily.HelveticaBold );
			font.Size = 10;
		
			string text     = "Copyright 2005 - Page ";
			SizeF size      = footer.Graphics.MeasureString( text, font );
			PointF location = new PointF( doc.LastPage.DrawingWidth - size.Width - 25, 10 );

			footer.Graphics.DrawText( location, text, font );

			location.X += size.Width;
			footer.Graphics.DrawText( location, string.Empty, font );

			//To add Page numbers to the pdf document.
			footer.LastVariable.DataColumnName =
				PageDictionaryKeys.PageIndex.ToString( CultureInfo.InvariantCulture );

			IPDFGraphicState props = doc.CreateGraphicState();
			props.ForeColor = Color.Gray;
			IPDFFont textFont = doc.Fonts.Add( FontBaseFamily.HelveticaOblique );
			textFont.Size = 8;
			props.BreakBehavior = AutoBreakBehavior.Cropping;

			float width = doc.LastPage.DrawingWidth;

			
			// add border effect on demand
			
				SizeF footerSize = footer.Size;
				footerSize.Height += 6;

				Color activeColor = Color.FromArgb( 139, 164, 204 );

				props = doc.CreateGraphicState();
				props.ForeColor = activeColor;
				footer.Graphics.DrawLine( 0, 0, width, 0 );
				footer.Graphics.DrawLine( 0, footerSize.Height, width, footerSize.Height );

				props = doc.CreateGraphicState();
				props.LineWidth = 2;
				props.ForeColor = activeColor;
				footer.Graphics.DrawLine( 0, 2, width, 2, props );
				footer.Graphics.DrawLine( 0, footerSize.Height - 2, width, footerSize.Height - 2, props );

				footer.Graphics.DrawLine( 0, 5, width, 5 );
				footer.Graphics.DrawLine( 0, footerSize.Height - 5, width, footerSize.Height - 5 );
		
			doc.Footer = footer;
		}



	}
}
